module Fenix
  class Response
    attr_accessor :body
    attr_accessor :headers
    attr_accessor :status

    def initialize(body: [], status: 200, headers: { 'Content-Type' => 'text/html; charset=utf-8' })
      @body, @headers, @status = body, headers, status
    end

    def finish
      headers['Content-Length'] ||= body.each.map(&:size).inject(0, &:+).to_s
      [status, headers, body]
    end

    def write(string)
      self.body << string
    end

    def [](key)
      @headers[key]
    end

    def []=(key, value)
      @headers[key] = value
    end
  end # Request
end # Fenix